var sServerURL="https://dsservices.aizo.com";

try {
	if (Property.getNode('/config/webservice-api/base-url')!=null) {
		sServerURL=Property.getNode('/config/webservice-api/base-url').getValue();
	}
} catch (e) {}


var RemoteConnectivity={	
		makePostCall:function(sFunction, options, sData) {
		    var extraheaders = [];
		    lInfo.logln("making post " + sFunction + ' to ' + sServerURL + 'with data ' + sData);
			try {
			    if (options==null)
                    options= { 'debug' : 0};
                else
                    options.debug=0;
			    var h = new HTTP(options);
			    var code = h.post(sServerURL + sFunction, '', sData);
			    if (code.status.valueOf() === 200) {
			    	lInfo.logln( ': OK [' + code.status + ']');
			    } else {
			    	lInfo.logln(': FAILED! Server replied: "' + code.status + '"');
			    }
		    	lInfo.logln(code.body);
		    	return JSON.parse(code.body);
			} catch (e) {
				lWarn.logln("Error during upload: ");
			    for (var i in e) {
			        lWarn.logln(i + ': ' + e[i]);
			    }
			}
			return 0;
		},
		makeCall:function(sFunction,options) {
		    var extraheaders = [];
		    lInfo.logln("making " + sFunction + ' to ' + sServerURL);
			try {
				if (options==null)
					options= { 'debug' : 0};
				else
					options.debug=0;
			    var h = new HTTP(options);
			    var code = h.get(sServerURL + sFunction, '');
			    if (code.status.valueOf() === 200) {
			    	lInfo.logln( ': OK [' + code.status + ']');
			    } else {
			    	lInfo.logln(': FAILED! Server replied: "' + code.status + '"');
			    }
		    	lInfo.logln(code.body);
		    	return JSON.parse(code.body);
			} catch (e) {
				lWarn.logln("Error during upload: ");
			    for (var i in e) {
			        lWarn.logln(i + ': ' + e[i]);
			    }
			}
			return 0;
		},
		makeLocalCall:function(sURL) {
		    var extraheaders = [];
			try {
			    var h = new HTTP( { 'debug' : 0 }, extraheaders);
			    var code = h.get('http://localhost:8088' + sURL, '');
			    if (code.status.valueOf() === 200) {
			    	lInfo.logln( ': OK [' + code.status + ']');
			    } else {
			    	lInfo.logln(': FAILED! Server replied: "' + code.status + '"');
			    }
		    	lInfo.logln(code.body);
		    	return JSON.parse(code.body);
			} catch (e) {
				lWarn.logln("Error during upload: ");
			    for (var i in e) {
			        lWarn.logln(i + ': ' + e[i]);
			    }
			}
			return 0;
		},
		CheckUserByMAC:function() {
			var sMac=this.getMyMac();
			lInfo.logln("CheckUserByMAC");
			return this.makeCall("/internal/accessmanagement/v1_0/Account/CheckUserByMAC?macaddress=" + sMac,{username:'dss@aizo.com',password:'Qeww1343_eWx'});
		},
		CheckExistingTempdSConfiguratorLink : function() {
		    lInfo.logln("CheckExistingTempdSConfiguratorLink");
		    var sParameters =  "token=" + this.getOSPToken() + "&dssid=" + this.getMyDSID() + "&type=Installer";
            return this.makePostCall("/internal/accessmanagement/v1_0/RemoteConnectivity/CheckExistingTempdSConfiguratorLink"+sParameters,{username:'dss@aizo.com',password:'Qeww1343_eWx'}, sParameters);          
		},
		DeleteApplicationToken: function(token) {
		    lInfo.logln("DeleteApplicationToken");
			Property.getNode('/system/security/applicationTokens/enabled').removeChild(token);	
		},		
		getMyMac: function(){
			return Property.getProperty('/system/host/interfaces/eth0/mac');
		},
		getMyDSID:function(){
			return Property.getProperty('/system/dSID');			
		},
		getMySGTIN:function() {
			return Property.getProperty('/system/dSID');
		},
		enableToken:function(TokenName) {
			var name=Property.getNode('/system/security/applicationTokens/pending/' + TokenName+'/applicationName').getValue();
			Property.setProperty('/system/security/applicationTokens/enabled/' + TokenName + "/token", TokenName);
			Property.setFlag('/system/security/applicationTokens/enabled/' + TokenName + "/token", 'ARCHIVE', true);
			Property.setProperty('/system/security/applicationTokens/enabled/' + TokenName + "/applicationName", name);
			Property.setFlag('/system/security/applicationTokens/enabled/' + TokenName + "/applicationName", 'ARCHIVE', true);
			Property.setProperty('/system/security/applicationTokens/enabled/' + TokenName + "/user", "dssadmin");
			Property.setFlag('/system/security/applicationTokens/enabled/' + TokenName + "/user", 'ARCHIVE', true);			
			Property.setProperty('/system/security/applicationTokens/enabled/' + TokenName + "/source", "remote-connectivity");
			Property.setFlag('/system/security/applicationTokens/enabled/' + TokenName + "/source", 'ARCHIVE', true);			
			Property.getNode('/system/security/applicationTokens/pending').removeChild(TokenName );	
		},
		generateToken:function(TokenName) {	
			// get a token
			var tempToken=this.makeLocalCall('/json/system/requestApplicationToken?applicationName=' + TokenName);
			Property.setProperty('/system/security/applicationTokens/enabled/' + tempToken.result.applicationToken + "/token", tempToken.result.applicationToken);
			Property.setFlag('/system/security/applicationTokens/enabled/' + tempToken.result.applicationToken + "/token", 'ARCHIVE', true);
			Property.setProperty('/system/security/applicationTokens/enabled/' + tempToken.result.applicationToken + "/applicationName", TokenName);
			Property.setFlag('/system/security/applicationTokens/enabled/' + tempToken.result.applicationToken + "/applicationName", 'ARCHIVE', true);
			Property.setProperty('/system/security/applicationTokens/enabled/' + tempToken.result.applicationToken + "/user", "dssadmin");
			Property.setFlag('/system/security/applicationTokens/enabled/' + tempToken.result.applicationToken + "/user", 'ARCHIVE', true);
			Property.setProperty('/system/security/applicationTokens/enabled/' + tempToken.result.applicationToken + "/source", "remote-connectivity");
			Property.setFlag('/system/security/applicationTokens/enabled/' + tempToken.result.applicationToken + "/source", 'ARCHIVE', true);					
			Property.getNode('/system/security/applicationTokens/pending').removeChild(tempToken.result.applicationToken );	
			return tempToken.result.applicationToken;
		},
		getOSPToken:function() {
			Property.load();
			var ospToken=Property.getNode('OSPToken');
			if (ospToken==null) {
				Property.setProperty('OSPToken', this.generateToken('RemoteConnectivity'));
				Property.setFlag('OSPToken', 'ARCHIVE', true);
				Property.store();			
				ospToken=Property.getNode('OSPToken');
			}
			return ospToken.getValue();
		},
		
};
var DSSService={
		GetRooms:function () {},
		GetDevices:function () {},
		GetDeviceDetails:function () {}
};